#include "stdafx.h"
#include "Common.h"
#include "Ts1segFilter.h"
#include "TsPatPacket.h"
#include "TsPmtPacket.h"

CTs1segFilter::CTs1segFilter(IEventHandler *pEventHandler)
	: CMediaDecoder(pEventHandler, 1, 1)
	, m_bUpdatePat( TRUE )
#if _ENABLE_STREAM_FILTER
	, m_bEnableStreamFilter( FALSE )
	, m_bEnableVideoStream( TRUE )
	, m_bEnableAudioStream( TRUE )
	, m_bEnableCaptionStream( TRUE )
	, m_bEnableDataStream( TRUE )
	, m_bUpdatePmt( TRUE )
#endif
{
	this->Reset();
#if _ENABLE_STATICPASSTABLE
//	this->m_wStaticPassTable.insert( 0x0000 );	// PAT(ZOł͕sv)
//	this->m_wStaticPassTable.insert( 0x0001 );	// CAT
	this->m_wStaticPassTable.insert( 0x0010 );	// NIT
	this->m_wStaticPassTable.insert( 0x0011 );	// SDT/BAT
	this->m_wStaticPassTable.insert( 0x0012 );	// EIT
	this->m_wStaticPassTable.insert( 0x0026 );	// EIT(nfW^erW)
	this->m_wStaticPassTable.insert( 0x0027 );	// EIT(nfW^erW)
	this->m_wStaticPassTable.insert( 0x0013 );	// RST
	this->m_wStaticPassTable.insert( 0x0014 );	// TDT/TOT
	this->m_wStaticPassTable.insert( 0x0017 );	// DCT
	this->m_wStaticPassTable.insert( 0x001E );	// DIT
	this->m_wStaticPassTable.insert( 0x001F );	// SIT
	this->m_wStaticPassTable.insert( 0x0020 );	// LIT
	this->m_wStaticPassTable.insert( 0x0021 );	// ERT
	this->m_wStaticPassTable.insert( 0x0022 );	// PCAT
	this->m_wStaticPassTable.insert( 0x0023 );	// SDTT
	this->m_wStaticPassTable.insert( 0x0028 );	// SDTT(nfW^erW)
	this->m_wStaticPassTable.insert( 0x0024 );	// BIT
	this->m_wStaticPassTable.insert( 0x0025 );	// NBIT
	this->m_wStaticPassTable.insert( 0x0025 );	// LDT
	this->m_wStaticPassTable.insert( 0x0029 );	// CDT
	this->m_wStaticPassTable.insert( 0x002F );	// dt[wb_
//	this->m_wStaticPassTable.insert( 0x1FFF );	// kpPbg
#endif
}

CTs1segFilter::~CTs1segFilter()
{
}

const bool CTs1segFilter::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	CBlockLock Lock( &this->m_DecoderLock );

	CTsPacket* t_pcTsPacket = static_cast< CTsPacket* >( pMediaData );
	WORD t_wPid = t_pcTsPacket->GetPID();

	if( 0x1fc8 == t_wPid )	// ZOPMTT(dꂽԑgɂ͑ΉĂȂ)
//	if( ( 0x1fc8 <= t_wPid ) && ( t_wPid <= 0x1fcf ) )	// ZOPMTT
	{
		this->PmtProcessor( t_pcTsPacket );
	}
	else if( this->m_bUpdatePat && ( t_wPid == 0x0000 ) )	// PATT
	{
		this->PatProcessor( t_pcTsPacket );
	}

	// PMTɋLꂽPIDƁAɕKvȌŒPID𓧉߂
	if( ( this->m_wDynamicPassTable.find( t_wPid ) != this->m_wDynamicPassTable.end() )
#if _ENABLE_STATICPASSTABLE
	 || ( this->m_wStaticPassTable.find( t_wPid ) != this->m_wStaticPassTable.end() )
#else
	 || ( 0x0000 == t_wPid )								// PAT͒ʉ߂
	 || ( ( 0x0010 <= t_wPid ) && ( t_wPid <= 0x0030 ) )	// ŒPID́A͈͂œĂĂ܂
#endif
	)
	{
		return this->OutputMedia( t_pcTsPacket, dwInputIndex );
	}

	return true;
}

void CTs1segFilter::Reset()
{
	CBlockLock Lock( &this->m_DecoderLock );

	this->m_wDynamicPassTable.clear();
}

void CTs1segFilter::SetUpdatePat( BOOL t_bUpdate )
{
	this->m_bUpdatePat = t_bUpdate;
}

#if _ENABLE_STREAM_FILTER

void CTs1segFilter::EnabledStreamFilter( BOOL t_bEnabled )
{
	this->m_bEnableStreamFilter = t_bEnabled;
}

void CTs1segFilter::EnabledVideoStream( BOOL t_bEnabled )
{
	this->m_bEnableVideoStream = t_bEnabled;
}

void CTs1segFilter::EnabledAudioStream( BOOL t_bEnabled )
{
	this->m_bEnableAudioStream = t_bEnabled;
}

void CTs1segFilter::EnabledCaptionStream( BOOL t_bEnabled )
{
	this->m_bEnableCaptionStream = t_bEnabled;
}

void CTs1segFilter::EnabledDataStream( BOOL t_bEnabled )
{
	this->m_bEnableDataStream = t_bEnabled;
}

void CTs1segFilter::SetUpdatePmt( BOOL t_bUpdate )
{
	this->m_bUpdatePmt = t_bUpdate;
}

#endif

void CTs1segFilter::PatProcessor( CTsPacket* t_pcTsPacket )
{
	// PATZÔ݂ɏ
	CTsPatPacket t_cTsPatPacket;

	t_cTsPatPacket.StorePacket( t_pcTsPacket );

	// lbg[NPID/ZOPMT̂ݎc(폜̓ŝŋtŒׂ)
	for( INT32 t_nIndex = static_cast< INT32 >( t_cTsPatPacket.GetPmtPidSize() ) ; t_nIndex-- ;  )
	{
		CTsPatPacket::STPmt& tr_stPmt = t_cTsPatPacket.GetPmtPid( t_nIndex );

		if( ( tr_stPmt.m_wPmt == 0x0010 ) || ( ( 0x1fc8 <= tr_stPmt.m_wPmt ) && ( tr_stPmt.m_wPmt <= 0x1fcf ) ) )
		{
		}
		else
		{
			// 폜
			t_cTsPatPacket.RemovePmtPid( t_nIndex );
		}
	}
	
	// PMT̓e
	t_cTsPatPacket.UpdatePacket( t_pcTsPacket );
}

void CTs1segFilter::PmtProcessor( CTsPacket* t_pcTsPacket )
{
	// ʉ߂PMTXgAbv
	this->m_wDynamicPassTable.clear();

	CTsPmtPacket t_cTsPmtPacket;

	t_cTsPmtPacket.StorePacket( t_pcTsPacket );
	
	INT32 t_nSize = static_cast< INT32 >( t_cTsPmtPacket.GetEsPidSize() );

	// ʉ߂PIDXgAbv(폜̓ŝŋtŒׂ)
	for( INT32 t_nIndex = static_cast< INT32 >( t_cTsPmtPacket.GetEsPidSize() ) ; t_nIndex-- ;  )
//	for( INT32 t_nIndex = 0 ; t_nIndex < t_nSize ; t_nIndex++ )
	{
		CTsPmtPacket::STPid& tr_stPid = t_cTsPmtPacket.GetEsPid( t_nIndex );
#if _ENABLE_STREAM_FILTER
		if( this->m_bEnableStreamFilter )
		{
			BOOL t_bPassThrough = FALSE;
			// ݒ肵ނ̃Xg[ʉ߂
			switch( tr_stPid.m_byteType )
			{
//			case STREAM_TYPE_MPEG2:
//				if( 1 ) { t_wPid = tr_stPid.m_wPid; }
//				break;
			case STREAM_TYPE_H264:
				if( this->m_bEnableVideoStream ) { t_bPassThrough = TRUE; }
				break;
			case STREAM_TYPE_AAC:
				if( this->m_bEnableAudioStream ) { t_bPassThrough = TRUE; }
				break;
			case STREAM_TYPE_CAPTION:
				if( this->m_bEnableCaptionStream ) { t_bPassThrough = TRUE; }
				break;
			case STREAM_TYPE_DATACARROUSEL:
				if( this->m_bEnableDataStream ) { t_bPassThrough = TRUE; }
				break;
			default:
				t_bPassThrough = TRUE;
				break;
			}

			if( t_bPassThrough )
			{
				this->m_wDynamicPassTable.insert( tr_stPid.m_wPid );
			}
			else
			{
				t_cTsPmtPacket.RemoveEsPid( t_nIndex );
			}
		}
		else
		{
			this->m_wDynamicPassTable.insert( tr_stPid.m_wPid );
		}

#else
		this->m_wDynamicPassTable.insert( tr_stPid.m_wPid );
#endif
	}

	this->m_wDynamicPassTable.insert( t_cTsPmtPacket.GetPmtPid() );
	this->m_wDynamicPassTable.insert( t_cTsPmtPacket.GetPcrPid() );

#if _ENABLE_STREAM_FILTER
	// PMT̏
	if( this->m_bEnableStreamFilter && this->m_bUpdatePmt )
	{
		t_cTsPmtPacket.UpdatePacket( t_pcTsPacket );
	}
#endif
}
