#include "stdafx.h"
#include "TsPatPacket.h"
#include "TsUtilClass.h"

CTsPatPacket::CTsPatPacket(void)
	: m_dwCrc32( 0 )
{
}

CTsPatPacket::~CTsPatPacket()
{
}

void CTsPatPacket::StorePacket( CTsPacket* t_pcTsPacket )
{
	// yC[h̉
	{
		BYTE* t_bytePayload = t_pcTsPacket->GetData() + 5;
		BYTE* t_byteCurrent = t_bytePayload;

		// e[u
		t_byteCurrent += 1;

		// ZbVV^NXw
		// ZNV
		WORD t_wSectionLength = ( ( static_cast< WORD >( t_byteCurrent[ 0 ] ) << 8 ) | static_cast< WORD >( t_byteCurrent[ 1 ] ) ) & 0x0FFF;
		t_byteCurrent += 2;

		// PMTf[^ŏIʒuvZ
		BYTE* t_bytePayloadEnd = t_byteCurrent + t_wSectionLength - 4;	// CRC

		// gX|[gXg[
		t_byteCurrent += 2;

		// o[Wԍ/JglNXgw
		t_byteCurrent += 1;

		// ZbVԍ
		t_byteCurrent += 1;

		// ŏIZNVԍ
		t_byteCurrent += 1;

		// PMT
		while( t_byteCurrent < t_bytePayloadEnd )
		{
			STPmt t_stPmt;

			// ԑgԍ
			t_stPmt.m_wProgramCode = ( static_cast< WORD >( t_byteCurrent[ 0 ] ) << 8 ) | static_cast< WORD >( t_byteCurrent[ 1 ] );
			t_byteCurrent += 2;

			// lbg[NPID/PMT_PID
			t_stPmt.m_wPmt = ( ( static_cast< WORD >( t_byteCurrent[ 0 ] ) << 8 ) | static_cast< WORD >( t_byteCurrent[ 1 ] ) ) & 0x1FFF;
			t_byteCurrent += 2;

			this->m_stPmts.push_back( t_stPmt );
		}

		// CRC̎擾
		this->m_dwCrc32 = ( static_cast< DWORD >( t_byteCurrent[ 0 ] ) << 24 )
						| ( static_cast< DWORD >( t_byteCurrent[ 1 ] ) << 16 )
						| ( static_cast< DWORD >( t_byteCurrent[ 2 ] ) << 8 )
						| static_cast< DWORD >( t_byteCurrent[ 3 ] );
	}
}

void CTsPatPacket::UpdatePacket( CTsPacket* t_pcTsPacket )
{
	// yC[h̏
	{
		INT32 t_nSize = static_cast< INT32 >( this->m_stPmts.size() );
		BYTE* t_bytePayload = t_pcTsPacket->GetData() + 5;
		BYTE* t_byteCurrent = t_bytePayload;

		// e[u
		t_byteCurrent += 1;

		// ZbVV^NXw
		// ZNV
		WORD t_wSectionLength = 0xB000 | ( 5 + ( t_nSize * 4 ) + 4 );
		t_byteCurrent[ 0 ] = static_cast< BYTE >( t_wSectionLength >> 8 );
		t_byteCurrent[ 1 ] = static_cast< BYTE >( t_wSectionLength & 0xFF );
		t_byteCurrent += 2;

		// gX|[gXg[
		t_byteCurrent += 2;

		// o[Wԍ/JglNXgw
		t_byteCurrent += 1;

		// ZbVԍ
		t_byteCurrent += 1;

		// ŏIZNVԍ
		t_byteCurrent += 1;

		// PMT
		for( INT32 t_nIndex = 0 ; t_nIndex < t_nSize ; t_nIndex++ )
		{
			STPmt& tr_stPmt = this->m_stPmts[ t_nIndex ];

			t_byteCurrent[ 0 ] = static_cast< BYTE >( tr_stPmt.m_wProgramCode >> 8 );
			t_byteCurrent[ 1 ] = static_cast< BYTE >( tr_stPmt.m_wProgramCode & 0xFF );
			t_byteCurrent += 2;

			WORD t_wPmtPid = 0xE000 | tr_stPmt.m_wPmt;
			t_byteCurrent[ 0 ] = static_cast< BYTE >( t_wPmtPid >> 8 );
			t_byteCurrent[ 1 ] = static_cast< BYTE >( t_wPmtPid & 0xFF );
			t_byteCurrent += 2;

		}
		
		// CRC
		DWORD t_dwCrc32 = CCrcCalculator::CalcCrc32( t_bytePayload, t_byteCurrent - t_bytePayload );

		t_byteCurrent[ 0 ] = static_cast< BYTE >( ( t_dwCrc32 >> 24 ) & 0xFF );
		t_byteCurrent[ 1 ] = static_cast< BYTE >( ( t_dwCrc32 >> 16 ) & 0xFF );
		t_byteCurrent[ 2 ] = static_cast< BYTE >( ( t_dwCrc32 >> 8 ) & 0xFF );
		t_byteCurrent[ 3 ] = static_cast< BYTE >( t_dwCrc32 & 0xFF );
		t_byteCurrent += 4;

		// 0xFFŖ߂
	}
}

size_t CTsPatPacket::GetPmtPidSize(void)
{
	return this->m_stPmts.size();
}

CTsPatPacket::STPmt& CTsPatPacket::GetPmtPid( INT32 t_nIndex )
{
	return this->m_stPmts[ t_nIndex ];
}

void CTsPatPacket::RemovePmtPid( INT32 t_nIndex )
{
	this->m_stPmts.erase( this->m_stPmts.begin() + t_nIndex );
}


