#include "stdafx.h"
#include "TsPmtPacket.h"
#include "TsUtilClass.h"

CTsPmtPacket::CTsPmtPacket(void)
	: m_wPmtPid( 0 )
	, m_wPcrPid( 0 )
{
}

CTsPmtPacket::~CTsPmtPacket()
{
}

void CTsPmtPacket::StorePacket( CTsPacket* t_pcTsPacket )
{
	// wb_̉
	{
		BYTE* t_byteCurrent = t_pcTsPacket->GetData();

		// wb_
		t_byteCurrent += 1;

		// PMT PID
		this->m_wPmtPid = ( ( static_cast< WORD >( t_byteCurrent[ 0 ] ) << 8 ) | static_cast< WORD >( t_byteCurrent[ 1 ] ) ) & 0x1FFF;
		t_byteCurrent += 2;
	}

	// yC[h̉
	{
		BYTE* t_bytePayload = t_pcTsPacket->GetData() + 5;
		BYTE* t_byteCurrent = t_bytePayload;

		// e[u
		t_byteCurrent += 1;

		// ZNV擾
		WORD t_wSectionLength = ( ( static_cast< WORD >( t_byteCurrent[ 0 ] ) << 8 ) | static_cast< WORD >( t_byteCurrent[ 1 ] ) ) & 0x0FFF;
		t_byteCurrent += 2;

		// PIDf[^ŏIʒuvZ
		BYTE* t_bytePayloadEnd = t_byteCurrent + t_wSectionLength - 4;	// CRC

		// ԑgԍ
		t_byteCurrent += 2;

		// o[Wԍ/JglNXgw
		t_byteCurrent += 1;

		// ZbVԍ
		t_byteCurrent += 1;

		// ŏIZNVԍ
		t_byteCurrent += 1;

		// PCR PID
		this->m_wPcrPid = ( ( static_cast< WORD >( t_byteCurrent[ 0 ] ) << 8 ) | static_cast< WORD >( t_byteCurrent[ 1 ] ) ) & 0x1FFF;
		t_byteCurrent += 2;

		// ԑg񒷂擾
		WORD t_wPcrLength = ( ( static_cast< WORD >( t_byteCurrent[ 0 ] ) << 8 ) | static_cast< WORD >( t_byteCurrent[ 1 ] ) ) & 0x0FFF;
		t_byteCurrent += 2;

		// Lqq̈1
		t_byteCurrent += t_wPcrLength;

		// PID
		while( t_byteCurrent < t_bytePayloadEnd )
		{
			STPid t_stPid;

			// Xg[`
			t_stPid.m_byteType = *t_byteCurrent;
			t_byteCurrent += 1;

			// ES PID
			t_stPid.m_wPid = ( ( static_cast< WORD >( t_byteCurrent[ 0 ] ) << 8 ) | static_cast< WORD >( t_byteCurrent[ 1 ] ) ) & 0x1FFF;
			t_byteCurrent += 2;

			// ES񒷂擾
			WORD t_wEsInfoLength = ( ( static_cast< WORD >( t_byteCurrent[ 0 ] ) << 8 ) | static_cast< WORD >( t_byteCurrent[ 1 ] ) ) & 0x0FFF;
			t_byteCurrent += 2;

			// Lqq̈2
			t_stPid.m_byteEsInfo.resize( t_wEsInfoLength );
			::memcpy( &( t_stPid.m_byteEsInfo[ 0 ] ),  t_byteCurrent, t_wEsInfoLength );
			t_byteCurrent += t_wEsInfoLength;

			this->m_stPids.push_back( t_stPid );
		}
	}
}

void CTsPmtPacket::UpdatePacket( CTsPacket* t_pcTsPacket )
{
	// wb_̏
	{
		BYTE* t_byteCurrent = t_pcTsPacket->GetData();

		// wb_
		t_byteCurrent += 1;

		// PMT PID
/*	̂ƂA@\͕KvȂ
		t_byteCurrent[ 0 ] = static_cast< BYTE >( ( this->m_wPmtPid >> 8 ) & 0x1F );
		t_byteCurrent[ 1 ] = static_cast< BYTE >( this->m_wPmtPid & 0xFF );
*/
		t_byteCurrent += 2;
	}
	// yC[h̏
	{
		BYTE* t_bytePayload = t_pcTsPacket->GetData() + 5;
		BYTE* t_byteCurrent = t_bytePayload;
		BYTE* t_pbyteSectionLength = NULL;

		// e[u
		t_byteCurrent += 1;

		// ZNV(ŌvZ)
		t_pbyteSectionLength = t_byteCurrent;
		t_byteCurrent += 2;

		// ԑgԍ
		t_byteCurrent += 2;

		// o[Wԍ/JglNXgw
		t_byteCurrent += 1;

		// ZbVԍ
		t_byteCurrent += 1;

		// ŏIZNVԍ
		t_byteCurrent += 1;

		// PCR PID
/*	̂ƂA@\͕KvȂ
		t_byteCurrent[ 0 ] = static_cast< BYTE >( ( this->m_wPcrPid >> 8 ) & 0x1F );
		t_byteCurrent[ 1 ] = static_cast< BYTE >( this->m_wPcrPid & 0xFF );
*/
		t_byteCurrent += 2;

		// ԑg񒷂擾
		WORD t_wPcrLength = ( ( static_cast< WORD >( t_byteCurrent[ 0 ] ) << 8 ) | static_cast< WORD >( t_byteCurrent[ 1 ] ) ) & 0x0FFF;
/*	̂ƂA@\͕KvȂ
		t_byteCurrent[ 0 ] = static_cast< BYTE >( ( t_wPcrLength >> 8 ) & 0x0F );
		t_byteCurrent[ 1 ] = static_cast< BYTE >( t_wPcrLength & 0xFF );
*/
		t_byteCurrent += 2;

		// Lqq̈1
		t_byteCurrent += t_wPcrLength;

		// PID
		INT32 t_nSize = static_cast< INT32 >( this->m_stPids.size() );
		for( INT32 t_nIndex = 0 ; t_nIndex < t_nSize ; t_nIndex++ )
		{
			STPid& tr_stPid = this->m_stPids[ t_nIndex ];

			// Xg[`
			*t_byteCurrent = tr_stPid.m_byteType;
			t_byteCurrent += 1;

			// ES PID
			WORD t_wPid = 0xE000 | tr_stPid.m_wPid;
			t_byteCurrent[ 0 ] = static_cast< BYTE >( t_wPid >> 8 );
			t_byteCurrent[ 1 ] = static_cast< BYTE >( t_wPid & 0xFF );
			t_byteCurrent += 2;

			// ES񒷂擾
			WORD t_wEsInfoLength = static_cast< WORD >( tr_stPid.m_byteEsInfo.size() );
			WORD t_wEsInfoLengthT = 0xF000 | t_wEsInfoLength;
			t_byteCurrent[ 0 ] = static_cast< BYTE >( t_wEsInfoLengthT >> 8 );
			t_byteCurrent[ 1 ] = static_cast< BYTE >( t_wEsInfoLengthT & 0xFF );
			t_byteCurrent += 2;

			// Lqq̈2
			::memcpy( t_byteCurrent,  &( tr_stPid.m_byteEsInfo[ 0 ] ), t_wEsInfoLength );
			t_byteCurrent += t_wEsInfoLength;
		}

		// ZNV
		WORD t_wSectionLength = 0xB000 | static_cast< WORD >( ( t_byteCurrent + 4 ) - ( t_pbyteSectionLength + 2 ) );
		t_pbyteSectionLength[ 0 ] = static_cast< BYTE >( t_wSectionLength >> 8 );
		t_pbyteSectionLength[ 1 ] = static_cast< BYTE >( t_wSectionLength & 0xFF );

		// CRC
		DWORD t_dwCrc32 = CCrcCalculator::CalcCrc32( t_bytePayload, t_byteCurrent - t_bytePayload );

		t_byteCurrent[ 0 ] = static_cast< BYTE >( ( t_dwCrc32 >> 24 ) & 0xFF );
		t_byteCurrent[ 1 ] = static_cast< BYTE >( ( t_dwCrc32 >> 16 ) & 0xFF );
		t_byteCurrent[ 2 ] = static_cast< BYTE >( ( t_dwCrc32 >> 8 ) & 0xFF );
		t_byteCurrent[ 3 ] = static_cast< BYTE >( t_dwCrc32 & 0xFF );
		t_byteCurrent += 4;
	}
}

WORD CTsPmtPacket::GetPmtPid(void)
{
	return this->m_wPmtPid;
}

WORD CTsPmtPacket::GetPcrPid(void)
{
	return this->m_wPcrPid;
}

size_t CTsPmtPacket::GetEsPidSize(void)
{
	return this->m_stPids.size();
}

CTsPmtPacket::STPid& CTsPmtPacket::GetEsPid( INT32 t_nIndex )
{
	return this->m_stPids[ t_nIndex ];
}

void CTsPmtPacket::RemoveEsPid( INT32 t_nIndex )
{
	this->m_stPids.erase( this->m_stPids.begin() + t_nIndex );
}


