#include "stdafx.h"
//#include <windows.h>
#include <tchar.h>
//#include <string>

#include "BonTuner.h"

#pragma warning( disable : 4273 )
extern "C" __declspec(dllexport) IBonDriver* CreateBonDriver()
{
	return ( CBonTuner::ms_pcThis ) ? CBonTuner::ms_pcThis : ( ( IBonDriver* ) new CBonTuner );
}
#pragma warning( default : 4273 )

CBonTuner* CBonTuner::ms_pcThis = NULL;
HINSTANCE CBonTuner::ms_hModule = NULL;

#define STRBUFLEN( t_szBuffer ) ( sizeof( t_szBuffer ) / sizeof( t_szBuffer[ 0 ] ) )

CBonTuner::CBonTuner()
{
	ms_pcThis = this;

	std::wstring t_strDirectoryPath;	// BonDriver̃fBNgpX
	std::wstring t_strModulePath;		// BonDriver̃t@C
	std::wstring t_strSourceBonDriverPath;	// \[XƂBonDriver

	// DLLzuĂpX𒲂ׂ
	{
		WCHAR t_szModulePath[ 512 ] = L"";
		WCHAR t_szDrive[ _MAX_DRIVE ];
		WCHAR t_szDirectory[_MAX_DIR];
		WCHAR t_szFileName[ _MAX_FNAME ];
		WCHAR t_szExt[ _MAX_EXT ];
		WCHAR t_szDirectoryPath[ _MAX_PATH ];	// fBNgpX
		
		// ݂̃fBNg𒲂ׂ
		::GetModuleFileName( ms_hModule, t_szModulePath, STRBUFLEN( t_szModulePath ) );

		t_strModulePath = t_szModulePath;

		// tpX̕
		_tsplitpath_s(
			t_szModulePath,
			t_szDrive,  STRBUFLEN( t_szDrive ),
			t_szDirectory,  STRBUFLEN( t_szDirectory ),
			t_szFileName,  STRBUFLEN( t_szFileName ),
			t_szExt,  STRBUFLEN( t_szExt )
			);

		// fBNgpX쐬
		_tmakepath_s(
			t_szDirectoryPath, STRBUFLEN( t_szDirectoryPath ),
			t_szDrive,
			t_szDirectory,
			NULL,
			NULL
			);

		t_strDirectoryPath = t_szDirectoryPath;
	}

	// ݒǂݍ
	{
		std::wstring t_strIniFile;

		// ݒt@ĆADLL(gqȂ) + ".ini"
		t_strIniFile = t_strModulePath + L".ini";
		if( !::PathFileExists( t_strIniFile.c_str() ) )
		{
			// ݂Ȃꍇ́AftHg̃t@C
			t_strIniFile = t_strDirectoryPath + L"BonDriver_1segFilter.ini";
		}
		TRACE( ( L"yBonDriver_1segFilter::CBonTuner::CBonTunerzݒt@CpX:" + t_strIniFile ).c_str() );

		// \[XBonDriver擾
		{
			WCHAR t_szSourceBonDriverFileName[ _MAX_FNAME ];
			::GetPrivateProfileString(
				L"BonDriver_1segFilter",
				L"BonDriver",
				L"",
				t_szSourceBonDriverFileName,
				STRBUFLEN( t_szSourceBonDriverFileName ),
				t_strIniFile.c_str()
				);

			t_strSourceBonDriverPath = t_strDirectoryPath + t_szSourceBonDriverFileName;
		}

		// \[XBonDriver̉
		this->m_bRelease = ::GetPrivateProfileInt(
			L"BonDriver_1segFilter",
			L"Release",
			TRUE,
			t_strIniFile.c_str()
			);

		// PAT̏
		this->m_cTs1segFilter.SetUpdatePat( ::GetPrivateProfileInt(
			L"BonDriver_1segFilter",
			L"UpdatePAT",
			TRUE,
			t_strIniFile.c_str()
			) );

#if _ENABLE_STREAM_FILTER
		// PMT̏
		this->m_cTs1segFilter.EnabledStreamFilter( ::GetPrivateProfileInt(
			L"BonDriver_1segFilter",
			L"EnabledStreamFilter",
			FALSE,
			t_strIniFile.c_str()
			) );

		// ZO fʉ߂
		this->m_cTs1segFilter.EnabledVideoStream( ::GetPrivateProfileInt(
			L"BonDriver_1segFilter",
			L"VideoStream",
			TRUE,
			t_strIniFile.c_str()
			) );

		// ZO ʉ߂
		this->m_cTs1segFilter.EnabledAudioStream( ::GetPrivateProfileInt(
			L"BonDriver_1segFilter",
			L"AudioStream",
			TRUE,
			t_strIniFile.c_str()
			) );

		// ZO ʉ߂
		this->m_cTs1segFilter.EnabledCaptionStream( ::GetPrivateProfileInt(
			L"BonDriver_1segFilter",
			L"CaptionStream",
			TRUE,
			t_strIniFile.c_str()
			) );

		// ZO f[^ʉ߂
		this->m_cTs1segFilter.EnabledDataStream( ::GetPrivateProfileInt(
			L"BonDriver_1segFilter",
			L"DataStream",
			TRUE,
			t_strIniFile.c_str()
			) );

		// PAT̏
		this->m_cTs1segFilter.SetUpdatePmt( ::GetPrivateProfileInt(
			L"BonDriver_1segFilter",
			L"UpdatePMT",
			TRUE,
			t_strIniFile.c_str()
			) );

#endif
	}

	// DLL[h
	TRACE( ( L"yBonDriver_1segFilter::CBonTuner::CBonTunerz\[XBonDriver[h:" + t_strSourceBonDriverPath ).c_str() );
	this->m_piBonDriver = NULL;
	this->m_hBonDriverDll = ::LoadLibrary( t_strSourceBonDriverPath.c_str() );

	if( this->m_hBonDriverDll )
	{
		TRACE( L"yBonDriver_1segFilter::CBonTuner::CBonTunerz[h" );
		IBonDriver* (*t_fpCreateBonDriver)(void) = ( IBonDriver* (*)(void) )::GetProcAddress( this->m_hBonDriverDll, "CreateBonDriver" );

		this->m_piBonDriver = t_fpCreateBonDriver();
	}

	this->m_cSrcDecoder.SetOutputDecoder( &this->m_cTsPacketParser );
	this->m_cTsPacketParser.SetOutputDecoder( &this->m_cTs1segFilter );
	this->m_cTs1segFilter.SetOutputDecoder( &this->m_cTsBuffer );
}

CBonTuner::~CBonTuner()
{
//	CloseTunerĂяoȂsV̈AvP[V͖
//	this->CloseTuner();

	// BonDriver
	if( this->m_bRelease && this->m_piBonDriver )
	{
		this->m_piBonDriver->Release();
	}
	this->m_piBonDriver = NULL;

	// BonDriver.dll
	if( this->m_hBonDriverDll )
	{
		::FreeLibrary( this->m_hBonDriverDll );
	}
	this->m_hBonDriverDll = NULL;

	// |C^NA
	ms_pcThis = NULL;
}

const BOOL CBonTuner::OpenTuner(void)
{
	if( !this->m_piBonDriver )
	{
		TRACE( L"yBonDriver_1segFilter::CBonTuner::OpenTunerz\[XBonDriver[hĂ܂" );
		return FALSE;
	}

	BOOL t_bResult = FALSE;
	if( this->m_cSrcDecoder.OpenTuner( this->m_piBonDriver ) )
	{
		t_bResult = this->m_cSrcDecoder.Play();
	}
	return t_bResult;
}

void CBonTuner::CloseTuner(void)
{
	if( !this->m_piBonDriver )
	{
		TRACE( L"yBonDriver_1segFilter::CBonTuner::CloseTunerz\[XBonDriver[hĂ܂" );
		return;
	}
	//this->m_piBonDriver->CloseTuner();
	this->m_cSrcDecoder.Stop();
	this->m_cSrcDecoder.CloseTuner();
}

const BOOL CBonTuner::SetChannel(const BYTE bCh)
{
	if( !this->m_piBonDriver )
	{
		TRACE( L"yBonDriver_1segFilter::CBonTuner::SetChannelz\[XBonDriver[hĂ܂" );
		return FALSE;
	}
	return this->m_piBonDriver->SetChannel( bCh );
}

const float CBonTuner::GetSignalLevel(void)
{
	if( !this->m_piBonDriver )
	{
		TRACE( L"yBonDriver_1segFilter::CBonTuner::GetSignalLevelz\[XBonDriver[hĂ܂" );
		return 0.f;
	}
	return this->m_piBonDriver->GetSignalLevel();
}

const DWORD CBonTuner::WaitTsStream(const DWORD dwTimeOut)
{
/*
	if( !this->m_piBonDriver )
	{
		return WAIT_ABANDONED;
	}
	return this->m_piBonDriver->WaitTsStream( dwTimeOut );
*/
	DWORD t_dwRet = ::WaitForSingleObject( this->m_cTsBuffer.GetWriteEvent(), ( dwTimeOut ) ? dwTimeOut : INFINITE );

	switch( t_dwRet )
	{
		case WAIT_ABANDONED:
		case WAIT_OBJECT_0:
		case WAIT_TIMEOUT:
		case WAIT_FAILED:
			return t_dwRet;
	}
	return WAIT_FAILED;
}

const DWORD CBonTuner::GetReadyCount(void)
{
/*
	if( !this->m_piBonDriver )
	{
		return 0;
	}
	return this->m_piBonDriver->GetReadyCount();
*/
	return this->m_cTsBuffer.GetPacketCount() * TS_PACKETSIZE;
}

const BOOL CBonTuner::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
/*
	if( !this->m_piBonDriver )
	{
		return FALSE;
	}
	return this->m_piBonDriver->GetTsStream( pDst, pdwSize, pdwRemain );
*/
	BYTE* t_byteBuffer = this->m_cTsBuffer.PopPacketsBlock();
	if( !t_byteBuffer )
	{
		return FALSE;
	}
	::memcpy( pDst, t_byteBuffer, TS_PACKETSIZE * TS_PACKET_BLOCK );
	*pdwSize = TS_PACKETSIZE * TS_PACKET_BLOCK;
	*pdwRemain = this->m_cTsBuffer.GetPacketCount() * TS_PACKETSIZE;
	return TRUE;
}

const BOOL CBonTuner::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
/*
	if( !this->m_piBonDriver )
	{
		return FALSE;
	}
	return this->m_piBonDriver->GetTsStream( ppDst, pdwSize, pdwRemain );
*/
	BYTE* t_byteBuffer = this->m_cTsBuffer.PopPacketsBlock();
	if( !t_byteBuffer )
	{
		return FALSE;
	}
	*ppDst = t_byteBuffer;
	*pdwSize = TS_PACKETSIZE * TS_PACKET_BLOCK;
	*pdwRemain = this->m_cTsBuffer.GetPacketCount() * TS_PACKETSIZE;
	return TRUE;
}

void CBonTuner::PurgeTsStream(void)
{
/*
	if( !this->m_piBonDriver )
	{
		return;
	}
	this->m_piBonDriver->PurgeTsStream();
*/
	this->m_cSrcDecoder.Reset();
}


LPCTSTR CBonTuner::GetTunerName(void)
{
	IBonDriver2* t_piBonDriver = dynamic_cast< IBonDriver2* >( this->m_piBonDriver );
	if( t_piBonDriver )
	{
		this->m_strTunerName = t_piBonDriver->GetTunerName();
		this->m_strTunerName += L"(ZO)";
	}
	else
	{
		this->m_strTunerName = L"";
	}

	return this->m_strTunerName.c_str();
}

const BOOL CBonTuner::IsTunerOpening(void)
{
/*
	IBonDriver2* t_piBonDriver = dynamic_cast< IBonDriver2* >( this->m_piBonDriver );
	if( !t_piBonDriver )
	{
		return FALSE;
	}
	return t_piBonDriver->IsTunerOpening();
*/
	return this->m_cSrcDecoder.IsOpen();
}
	
LPCTSTR CBonTuner::EnumTuningSpace(const DWORD dwSpace)
{
	IBonDriver2* t_piBonDriver = dynamic_cast< IBonDriver2* >( this->m_piBonDriver );
	if( !t_piBonDriver )
	{
		TRACE( L"yBonDriver_1segFilter::CBonTuner::EnumTuningSpacez\[XBonDriver[hĂ܂" );
		return FALSE;
	}
	return t_piBonDriver->EnumTuningSpace( dwSpace );
}

LPCTSTR CBonTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel)
{
	IBonDriver2* t_piBonDriver = dynamic_cast< IBonDriver2* >( this->m_piBonDriver );
	if( !t_piBonDriver )
	{
		TRACE( L"yBonDriver_1segFilter::CBonTuner::EnumChannelNamez\[XBonDriver[hĂ܂" );
		return NULL;
	}
	return t_piBonDriver->EnumChannelName( dwSpace, dwChannel );
}

const BOOL CBonTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	IBonDriver2* t_piBonDriver = dynamic_cast< IBonDriver2* >( this->m_piBonDriver );
	if( !t_piBonDriver )
	{
		TRACE( L"yBonDriver_1segFilter::CBonTuner::SetChannelz\[XBonDriver[hĂ܂" );
		return FALSE;
	}
	return t_piBonDriver->SetChannel( dwSpace, dwChannel );
}
	
const DWORD CBonTuner::GetCurSpace(void)
{
	IBonDriver2* t_piBonDriver = dynamic_cast< IBonDriver2* >( this->m_piBonDriver );
	if( !t_piBonDriver )
	{
		TRACE( L"yBonDriver_1segFilter::CBonTuner::GetCurSpacez\[XBonDriver[hĂ܂" );
		return FALSE;
	}
	return t_piBonDriver->GetCurSpace();
}

const DWORD CBonTuner::GetCurChannel(void)
{
	IBonDriver2* t_piBonDriver = dynamic_cast< IBonDriver2* >( this->m_piBonDriver );
	if( !t_piBonDriver )
	{
		TRACE( L"yBonDriver_1segFilter::CBonTuner::GetCurChannelz\[XBonDriver[hĂ܂" );
		return FALSE;
	}
	return t_piBonDriver->GetCurChannel();
}

void CBonTuner::Release()
{
	delete this;
//	MessageBox( NULL, L"delete", L"", MB_OK );
}
